#include "common.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <string.h>

#ifdef __cplusplus
extern "C" {
#endif

int
LLVMFuzzerTestOneInput(const uint8_t *data, size_t size) {
    size_t i = 0;

    int8_t int8_eq_const_0_0;
    int64_t int64_eq_const_1_0;
    int32_t int32_eq_const_2_0;
    int64_t int64_eq_const_3_0;
    int8_t int8_eq_const_4_0;
    int16_t int16_eq_const_5_0;
    int32_t int32_eq_const_6_0;
    int16_t int16_eq_const_7_0;
    int64_t int64_eq_const_8_0;
    int32_t int32_eq_const_9_0;
    int8_t int8_eq_const_10_0;
    int16_t int16_eq_const_11_0;
    int64_t int64_eq_const_12_0;
    int64_t int64_eq_const_13_0;
    int16_t int16_eq_const_14_0;

    if (size < 63)
        return TEPHRA_EXIT_FAILURE;


    memcpy(&int8_eq_const_0_0, &data[i], 1);
    i += 1;
    memcpy(&int64_eq_const_1_0, &data[i], 8);
    i += 8;
    memcpy(&int32_eq_const_2_0, &data[i], 4);
    i += 4;
    memcpy(&int64_eq_const_3_0, &data[i], 8);
    i += 8;
    memcpy(&int8_eq_const_4_0, &data[i], 1);
    i += 1;
    memcpy(&int16_eq_const_5_0, &data[i], 2);
    i += 2;
    memcpy(&int32_eq_const_6_0, &data[i], 4);
    i += 4;
    memcpy(&int16_eq_const_7_0, &data[i], 2);
    i += 2;
    memcpy(&int64_eq_const_8_0, &data[i], 8);
    i += 8;
    memcpy(&int32_eq_const_9_0, &data[i], 4);
    i += 4;
    memcpy(&int8_eq_const_10_0, &data[i], 1);
    i += 1;
    memcpy(&int16_eq_const_11_0, &data[i], 2);
    i += 2;
    memcpy(&int64_eq_const_12_0, &data[i], 8);
    i += 8;
    memcpy(&int64_eq_const_13_0, &data[i], 8);
    i += 8;
    memcpy(&int16_eq_const_14_0, &data[i], 2);
    i += 2;


    if (int8_eq_const_0_0 == 118)
    if (int64_eq_const_1_0 == -4305061208573400032)
    if (int32_eq_const_2_0 == -714015946)
    if (int64_eq_const_3_0 == -7722439800640169476)
    if (int8_eq_const_4_0 == 88)
    if (int16_eq_const_5_0 == -5676)
    if (int32_eq_const_6_0 == 507027233)
    if (int16_eq_const_7_0 == -27709)
    if (int64_eq_const_8_0 == -6305219730824312001)
    if (int32_eq_const_9_0 == -1392401913)
    if (int8_eq_const_10_0 == -98)
    if (int16_eq_const_11_0 == 22643)
    if (int64_eq_const_12_0 == 6764731760182634806)
    if (int64_eq_const_13_0 == 3706966006107482958)
    if (int16_eq_const_14_0 == -30035)
        BOOM();

    return TEPHRA_EXIT_SUCCESS;
}

#ifdef __cplusplus
}
#endif
